
# Gets available hotbar slots and saves them as macro variables
data modify storage talon_toolbag:player bundle_contents.open_slots set value []
execute unless data entity @s Inventory[{Slot:0b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 0
execute unless data entity @s Inventory[{Slot:1b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 1
execute unless data entity @s Inventory[{Slot:2b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 2
execute unless data entity @s Inventory[{Slot:3b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 3
execute unless data entity @s Inventory[{Slot:4b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 4
execute unless data entity @s Inventory[{Slot:5b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 5
execute unless data entity @s Inventory[{Slot:6b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 6
execute unless data entity @s Inventory[{Slot:7b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 7
execute unless data entity @s Inventory[{Slot:8b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slots append value 8

# Sets obtained open slots into their macro variables in a nice, filling-hotbar order
data modify storage talon_toolbag:player bundle_contents.open_slot0 set from storage talon_toolbag:player bundle_contents.open_slots[0]
data modify storage talon_toolbag:player bundle_contents.open_slot1 set from storage talon_toolbag:player bundle_contents.open_slots[1]
data modify storage talon_toolbag:player bundle_contents.open_slot2 set from storage talon_toolbag:player bundle_contents.open_slots[2]
data modify storage talon_toolbag:player bundle_contents.open_slot3 set from storage talon_toolbag:player bundle_contents.open_slots[3]
data modify storage talon_toolbag:player bundle_contents.open_slot4 set from storage talon_toolbag:player bundle_contents.open_slots[4]
data modify storage talon_toolbag:player bundle_contents.open_slot5 set from storage talon_toolbag:player bundle_contents.open_slots[5]
data modify storage talon_toolbag:player bundle_contents.open_slot6 set from storage talon_toolbag:player bundle_contents.open_slots[6]
data modify storage talon_toolbag:player bundle_contents.open_slot7 set from storage talon_toolbag:player bundle_contents.open_slots[7]
# offhand check
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run data modify storage talon_toolbag:player bundle_contents.open_slot8 set from storage talon_toolbag:player bundle_contents.open_slots[8]

# If not enough slots, sets to Selected Slot to make sure enough macro variables exist later
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[0] run data modify storage talon_toolbag:player bundle_contents.open_slot0 set from entity @s SelectedItemSlot
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[1] run data modify storage talon_toolbag:player bundle_contents.open_slot1 set from entity @s SelectedItemSlot
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[2] run data modify storage talon_toolbag:player bundle_contents.open_slot2 set from entity @s SelectedItemSlot
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[3] run data modify storage talon_toolbag:player bundle_contents.open_slot3 set from entity @s SelectedItemSlot
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[4] run data modify storage talon_toolbag:player bundle_contents.open_slot4 set from entity @s SelectedItemSlot
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[5] run data modify storage talon_toolbag:player bundle_contents.open_slot5 set from entity @s SelectedItemSlot
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[6] run data modify storage talon_toolbag:player bundle_contents.open_slot6 set from entity @s SelectedItemSlot
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[7] run data modify storage talon_toolbag:player bundle_contents.open_slot7 set from entity @s SelectedItemSlot
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[8] run data modify storage talon_toolbag:player bundle_contents.open_slot8 set from entity @s SelectedItemSlot
# offhand check
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[0] run data modify storage talon_toolbag:player bundle_contents.open_slot0 set value 8
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[1] run data modify storage talon_toolbag:player bundle_contents.open_slot1 set value 8
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[2] run data modify storage talon_toolbag:player bundle_contents.open_slot2 set value 8
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[3] run data modify storage talon_toolbag:player bundle_contents.open_slot3 set value 8
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[4] run data modify storage talon_toolbag:player bundle_contents.open_slot4 set value 8
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[5] run data modify storage talon_toolbag:player bundle_contents.open_slot5 set value 8
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[6] run data modify storage talon_toolbag:player bundle_contents.open_slot6 set value 8
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[7] run data modify storage talon_toolbag:player bundle_contents.open_slot7 set value 8
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag unless data storage talon_toolbag:player bundle_contents.open_slots[8] run data modify storage talon_toolbag:player bundle_contents.open_slot8 set value 8