
# if no item was thrown advancement is invalid and is revoked
execute anchored eyes positioned ^ ^ ^ unless entity @n[type=item,sort=nearest,distance=..5,nbt={Age:0s}] run return run advancement revoke @s only talon_toolbag:toolbag_use

# saves bundle contents (including thrown item) into storage
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag run function talon_toolbag:save_mainhand_bundle_contents
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run function talon_toolbag:save_offhand_bundle_contents

# clears bundle contents to allow future steps to happen
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag run item modify entity @s weapon.mainhand {"function": "set_components", "components": {"minecraft:bundle_contents": []}}
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run item modify entity @s weapon.offhand {"function": "set_components", "components": {"minecraft:bundle_contents": []}}

# Gets open slots and saves them as variables (both use mainhand file now)
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag run function talon_toolbag:get_mainhand_open_slots
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run function talon_toolbag:get_mainhand_open_slots

# Swaps hotbar items into cloud storage (so it's empty when items are "instantly" picked up)
function talon_toolbag:enchant_tick

# If holding bundle in mainhand sets items back in hotbar slots
execute if data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag run function talon_toolbag:macro_fill_hotbar with storage talon_toolbag:player bundle_contents

# If not holding bundle in mainhand but one in offhand
execute unless data entity @s SelectedItem.components.minecraft:enchantments.levels.talon_toolbag:toolbag if data entity @s Inventory[{Slot:-106b}].components.minecraft:enchantments.levels.talon_toolbag:toolbag run function talon_toolbag:macro_fill_hotbar_offhand with storage talon_toolbag:player bundle_contents

# Only revokes after completion to prevent duplicate run bugs
advancement revoke @s only talon_toolbag:toolbag_use